%This function calculates a mxn matrix of correlation
function [Co, P]=Fast_Corr(IND, Matrix)
%IND is an index for the genes of interest
%Matrix is the micorarray matrix, rows for genes, and columns for
%experiments


if(size(IND,1) > size(IND,2))
    IND=IND';
end
n=length(IND);
Part=n*3;

N=size(Matrix,1);
REM=setdiff(1:N, IND);

Co=zeros(n,N);
P=zeros(n,N);

Iter=ceil((N-n)/Part);

%%get division
for(i=1:Iter)
    if(i<Iter)
        PartSet{i}=REM( (i-1)*Part+1: i*Part );
    else
        PartSet{i}=REM((i-1)*Part+1:end);
    end
end

for(i=1:Iter)
    callset=[IND, PartSet{i}];
    Ma=Matrix(callset, :);
    [c,p]=corrcoef(Ma');
    
    Co(:,callset)=c(1:n, :);
    P(:,callset)=p(1:n, :);
end


end

