% Usage:
%
% corrMat : correlation matrix
% sizeMat: size vector containing sizes for genes in each GOID 
% pval = p-value from the T-TEST2
%
% To use this function sizeMat must be GREATER than 1

function [h pval] = doTtest(corrMat, sizeMat)
%extract foreground matrix
pval = [];
corrMat = abs(corrMat);
bMat = zeros(length(corrMat), length(corrMat));
LCorr = corrMat(1:sizeMat(1), 1:sizeMat(1));   %corr matrix for the forground or the label of interest
[m, n] = size(LCorr);
bMat(1:m,1:n)=LCorr(1:m,1:n);
bCorr = bMat - corrMat;  % corr matrix for the background
bCorr = abs(bCorr);
mask = repmat(2, m, n);  % mask for cutting corr matrix of label of interest
Trimask = triu(mask, 1);
LData = LCorr(Trimask==2);  % corr data vector for the foreground or label of interest
[r, c] = size(bCorr);
maskB = repmat(2, r, c);
maskB(1:m, 1:n) = 0;  % mask for cutting out the background
TriMaskB = triu(maskB, 1);
BgData = bCorr(TriMaskB==2);
[h, pval, ci] = ttest2(LData, BgData,[],'right');
clear corrMat

