%This function produces ROC curves and AUC

function [auc,prec_at] =get_precision_aucPB(Pre,G, color)

recall_list=[0.01,0.1,0.5,0.8];
prec_at=zeros(4,1);

ind=find(G>0);

Th_List=unique(Pre(ind));
Th_List=[min(Pre);Th_List; max(Pre)];
Th_List=unique(Th_List);


AC_P=length(ind);
AC_N=length(G)-AC_P;

N=length(Th_List);

if(AC_P*AC_N==0 || N<3)
    auc=0.5;
    prec_at=0;%recall_list;
    return;
end


TP=zeros(N,1);
TN=zeros(N,1);
FP=zeros(N,1);
FN=zeros(N,1);


for(i=1:N)
    
    TH=Th_List(i);    
    I=find(Pre>=TH);
    J=find(Pre<TH);
    
    TP(i)=length(find(G(I)==1)); %TP should be 1, 2, 3..
    FP(i)=length(find(G(I)==0)); %TP should be 1, 2, 3..
    
    TN(i)=length(find(G(J)==0));
    FN(i)=length(find(G(J)==1));    
    
end%TH


FPR=FP/AC_N;
TPR=TP/AC_P;
    
Recall=TP./(TP+FN); %check Recall==TPR
Precision=TP./(TP+FP);

%plot(Recall, Precision);

for(i=1:4)
    [Y,I]=min(abs(Recall-recall_list(i)));
    prec_at(i)=Precision(I);
end

plot(FPR,TPR, char(color),'LineWidth',2);% for ROC
auc=0;
for(i=1:N-1)
    a=TPR(i);
    b=TPR(i+1);
    h=abs(FPR(i+1)-FPR(i));
    auc=auc+0.5*(a+b)*h;
end
auc=1-auc;
end
